> For the complete documentation index, see [llms.txt](https://docs.syncswap.xyz/api-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.syncswap.xyz/api-documentation/guides/request-swap-with-router.md).

# Request Swap with Router

In this simple example, we request a swap with the router.

```javascript
// JavaScript
// ...

// Encode path data.
const pathData: SwapPathData[] = route.paths.map(path => {
   
    const pathTokenInRoute = path.stepsWithAmount[0].tokenIn;
    const pathTokenIn = ethIn ? ZERO_ADDRESS : pathTokenInRoute;

    // Path data
    return {
        steps: path.stepsWithAmount.map((step, i) => {
            const isLastStep: boolean = i == (path.stepsWithAmount.length - 1);

            // send to next step or recipient for last step
            const stepTo: string = (
                isLastStep ? to : path.stepsWithAmount[i + 1].pool.pool
            );

            // Determine withdraw mode, to withdraw native ETH or wETH on last step.
            // 0 - vault internal transfer
            // 1 - withdraw and unwrap to naitve ETH
            // 2 - withdraw and wrap to wETH
            const withdrawMode: number = (isLastStep ? (ethOut ? 1 : 2) : 0);

            const data: string = defaultAbiCoder.encode(
                ["address", "address", "uint8"],
                [step.tokenIn, stepTo, withdrawMode], // tokenIn, to, withdraw mode
            );

            // Step data
            return {
                pool: step.pool.pool,
                data: data,
                callback: ZERO_ADDRESS, // we don't have a callback
                callbackData: '0x',
            };
        }),

        tokenIn: pathTokenIn,

        amountIn: path.amountIn,
    };
});

const args: any[] = [
    pathData,
    amountOutMin,
    deadline,
];

// Request the swap.
await router.swap(...args);

// ...
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.syncswap.xyz/api-documentation/guides/request-swap-with-router.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
